Project Chrono: chrono::vehicle::ChSuspensionTestRigDriver Class Reference

Public Member Functions | Protected Member Functions | Protected Attributes | Friends | List of all members
chrono::vehicle::ChSuspensionTestRigDriver Class Reference
VEHICLE module » Wheeled vehicles » Suspension test rig classes

## Description

Base class for a suspension test rig driver system.

A driver system must be able to report the current values of the inputs (left posts, right posts, steering). A concrete driver class must set the member variables m_displacementLeft, m_displacementRight, m_steering, and - if possible - the rates of change for the displacements (otherwise left at their default value of 0).

`#include <ChSuspensionTestRigDriver.h>`

Inheritance diagram for chrono::vehicle::ChSuspensionTestRigDriver:
[legend]

## Public Member Functions
double | GetSteering () const
| Get the driver steering input (in the range [-1,+1]).
const std::vector< double > & | GetDisplacementLeft () const
| Get the left post vertical displacement inputs (each in the range [-1,+1]).
const std::vector< double > & | GetDisplacementRight () const
| Get the right post vertical displacement inputs (each in the range [-1,+1]).
const std::vector< double > & | GetDisplacementSpeedLeft () const
| Get the left post displacement rates of change.
const std::vector< double > & | GetDisplacementSpeedRight () const
| Get the right post displacement rates of change.
bool | Started () const
| Return false while driver inputs are ignored (while the rig is reaching the ride height configuration) and true otherwise.
virtual bool | Ended () const
| Return true when driver stopped producing inputs.
bool | LogInit (const std::string &filename)
| Initialize output file for recording driver inputs.
bool | Log (double time)
| Record the current driver inputs to the log file.

## Protected Member Functions
virtual void | Initialize (int naxles)
| Initialize this driver system.
virtual void | Synchronize (double time)
| Update the state of this driver system at the current time.
virtual std::string | GetInfoMessage () const
| Get string message.
void | SetDisplacementLeft (int axle, double val, double min_val=-1, double max_val=1)
| Set the value for the driver left post displacement input.
void | SetDisplacementRight (int axle, double val, double min_val=-1, double max_val=1)
| Set the value for the driver right post displacement input.
void | SetSteering (double val, double min_val=-1, double max_val=1)
| Set the value for the driver steering input.

## Protected Attributes
int | m_naxles
| number of actuated axles
std::vector< double > | m_displLeft
| current value of left post displacements
std::vector< double > | m_displRight
| current value of right post displacements
std::vector< double > | m_displSpeedLeft
| current value of left post displacement rates of change
std::vector< double > | m_displSpeedRight
| current value of right post displacement rates of change
double | m_steering
| current value of steering input
double | m_delay
| time delay before generating inputs

## Friends
class | ChSuspensionTestRig

## Member Function Documentation

## ◆ Ended()

virtual bool chrono::vehicle::ChSuspensionTestRigDriver::Ended | ( |  | ) | const
| inlinevirtual

Return true when driver stopped producing inputs.

Reimplemented in chrono::vehicle::ChSuspensionTestRigDataDriver.

## ◆ Started()

bool chrono::vehicle::ChSuspensionTestRigDriver::Started | ( |  | ) | const

Return false while driver inputs are ignored (while the rig is reaching the ride height configuration) and true otherwise.

In general, outputs from the test rig should only be collected while Started returns true.

The documentation for this class was generated from the following files:

- D:/W/B/src/chrono-9.0.1/src/chrono_vehicle/wheeled_vehicle/test_rig/ChSuspensionTestRigDriver.h
- D:/W/B/src/chrono-9.0.1/src/chrono_vehicle/wheeled_vehicle/test_rig/ChSuspensionTestRigDriver.cpp